 
package org.iespuigcastellar.amtools;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.net.MalformedURLException;
import java.sql.SQLException;
import java.text.DateFormat;
import java.text.ParseException;
import java.util.Locale;
import java.util.ResourceBundle;

import org.iespuigcastellar.attendancemanager.core.CreatePDF;
import org.iespuigcastellar.attendancemanager.core.DatabaseStorage;
import org.iespuigcastellar.attendancemanager.core.Mailer;
import org.iespuigcastellar.attendancemanager.core.Teacher;

import com.itextpdf.text.DocumentException;

public class MailGroupReport {
	private DatabaseStorage database = new DatabaseStorage();
	private CreatePDF pdf= new CreatePDF();
	private ResourceBundle rb = ResourceBundle.getBundle("AttendanceManager");
	private DateFormat df = DateFormat.getDateInstance(DateFormat.SHORT, new Locale(rb.getString("locale")));
	private Mailer mail = new Mailer();

	public static void main(String args[]) {
		MailGroupReport app= new MailGroupReport(); 
//		try {
//			app.doit(1,"09/05/2010","20/05/2010","subject", "Text!!","1","dperez@localhost");
//		} catch (Exception e) {
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		}
		if(args.length==6){
			app.doit(Integer.parseInt(args[0]),args[1],args[2],args[3],args[4],args[5]);	
		}
		else if(args.length==7){
			try{
				app.doit(Integer.parseInt(args[0]),args[1],args[2],args[3],args[4],args[5],args[6]);
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		else System.out.println("Numero de argumentos incorrecto!!");
	}
	
	private void doit(int idgroup,String dateA, String dateB, String subject, String msgText,String report){
		Teacher t1=database.getGroupTeacher(idgroup);
		try{
			doit(idgroup,dateA,dateB,subject,msgText,report,t1.getEmail());
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	private void doit(int idgroup,String dateA, String dateB, String subject, String msgText,String report, String email) throws MalformedURLException, DocumentException, IOException, ParseException, SQLException{

		ByteArrayOutputStream byteArrayOutputStreamPDF= new ByteArrayOutputStream();

		if (!mail.isValidEmailAddress(email)){
			System.out.println("Dirección de e-mail incorrecta --> "+ email);
			System.exit(1);
		}
		else{
			String[] to = { email };	
			mail.setTo(to);
		}
		
		int op=Integer.parseInt(report);
		String filename= "Report_"+idgroup+".pdf";				
		
		java.util.Date dfecha1= df.parse(dateA);
		java.util.Date dfecha2= df.parse(dateB);
		
		if(op==1) byteArrayOutputStreamPDF = pdf.createReport1(idgroup, dfecha1, dfecha2);
		else if (op==2) byteArrayOutputStreamPDF =pdf.createReport2(idgroup, dfecha1, dfecha2);
		else if (op==3)byteArrayOutputStreamPDF = pdf.createReport3(idgroup, dfecha1);
		else {
			 System.out.println("Tipo de de informe incorrecto");
				System.exit(1);
		}
		
		byte[] byteArrayPDF = byteArrayOutputStreamPDF.toByteArray();
		
		mail.setSubject(subject);
		mail.setBodyText(msgText);
		mail.addMailAttachment(byteArrayPDF, "application/pdf", filename);
		mail.sendMail(); 	
	}
}