package org.iespuigcastellar.attendancemanager.core;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

import org.iespuigcastellar.attendancemanager.AttendancemanagerApplication;

public class Term implements Entity{
	private Integer idTerm;
	private String name = null;
	private String comment;
	private java.util.Date start = null;
	private java.util.Date end = null;
	
	/**
	 * Constructor de los nuevos Term. Al añadir un Term desde la aplicación,
	 * se usará este constructor.
	 * @param idTerm
	 * @param name
	 * @param comment
	 * @param start
	 * @param end
	 */
	public Term (Integer idTerm, String name, String comment, java.util.Date start, java.util.Date end){
//		try{
		
		setIdTerm(idTerm);
		
		if (name.equals("")) {
			Logger.log("No se puede crear un plazo con el nombre '' !!!!");			
		} else {
			setName(name);
		}
		
		if(comment.equals("")) setComment(null); else setComment(comment);				
		
//		if (start == null){
//			Logger.log("No se puede crear un plazo con la fecha de inicio '' !!!!");
//			//setStart(AttendancemanagerApplication.df.parse(""));
//			throw new Exception();
//		} else {
//			setStart(start);		
//		}
//		
//		//setStart(start);
//		if (end == null){
//			Logger.log("No se puede crear un plazo con la fecha de fin '' !!!!");
//			//setEnd(AttendancemanagerApplication.df.parse(""));
//			throw new Exception();
//		} else {
//			setEnd(end);		
//		}
		
		setStart(start);
		setEnd(end);
//		} catch(Exception e){
//			System.out.println("TERM CON FECHA CHUNGA!!!!!!!!");
//			e.printStackTrace();
//		}
		//setEnd(end);		
	}
	
	/**
	 * Constructor de los Term importados. Al importar un Term desde un csv,
	 * se usará este constructor.
	 * @param name
	 * @param comment
	 * @param startString fecha en formato de cadena SQL
	 * @param endString
	 * @throws ParseException cuando una de las fechas no se puede interpretar (De acuerdo
	 * a la locale seleccionada en el fichero properties)
	 */
	public Term(String name, String comment, String startString, String endString) throws ParseException{
		this(0, name, comment, (startString.equals(""))?null:AttendancemanagerApplication.df.parse(startString), (endString.equals(""))?null:AttendancemanagerApplication.df.parse(endString));
		//this(0, name, comment, AttendancemanagerApplication.df.parse(startString), AttendancemanagerApplication.df.parse(endString));
	}
	
	/**
	 * Método estático que devuelve un array con las cabeceras del csv
	 * @return devuelve un array con las cadenas de las cabeceras que deberían tener los csv de Term
	 */
	public static String[] getBasicProperties() {
		String columns[] =  {"name", "comment", "start", "end"};
		return columns;
	}

	public Integer getIdTerm() {
		return idTerm;
	}
	public void setIdTerm(Integer idTerm) {
		this.idTerm = idTerm;
	}
	public String getComment() {
		return comment;
	}
	public void setComment(String comment) {
		this.comment = comment;
	}
	public java.util.Date getStart() {
		return start;
	}
	public void setStart(java.util.Date start) {
		this.start = start;
	}
	public java.util.Date getEnd() {
		return end;
	}
	public void setEnd(java.util.Date end) {
		this.end = end;
	}
	public String getName() {
		return name;
	}
	
	/**
	 * Se añade él mismo a la base de datos
	 * @return el id del Term insertado
	 */
	public int add() {
		int id = 0;
		
		try {
			id = storage.addTerm(this);
		} catch(Exception e) {
			Logger.log("Term.add() -> " + this);
			e.printStackTrace();
		}
		
		return id;
	}
	
	/**
	 * Se elimina él mismo de la base de datos
	 */
	public void delete() {
		 storage.deleteTerm(this.idTerm);
	}
	
	/**
	 * Se modifica él mismo en la base de datos
	 * @return el código de retorno
	 */
	public int update() {
		return storage.updateTerm(this);
	}
	
	public void setName(String name) {
		this.name = name;
	}
}
